package models

import "time"

type ChartPermissionView struct {
	ChartPermissionId   int    `description:"权限ID"`
	ChartPermissionName string `description:"名称"`
	PermissionName      string `description:"权限名"`
	Remark              string `description:"备注"`
	ImageUrl            string `description:"图片地址"`
}

type ChartPermission struct {
	ChartPermissionId   int       `description:"问题ID"`
	ChartPermissionName string    `description:"名称"`
	PermissionName      string    `description:"权限名"`
	Sort                int       `description:"排序"`
	Enabled             int       `description:"是否可用"`
	CreatedTime         time.Time `description:"创建时间"`
	LastUpdatedTime     time.Time `description:"更新时间"`
	Remark              string    `description:"备注"`
	ImageUrl            string    `description:"图片地址"`
	ParentId            int       `description:"父级权限id"`
	IsPublic            int       `description:"是否是公有权限1:公有权限，0私有权限"`
}

type ChartPermissionResp[T any] struct {
	Ret    int
	Data   T
	Msg    string
	ErrMsg string
}

type ChartPermissionTreeView struct {
	ChartPermissionId int                        `description:"权限ID"`
	PermissionName    string                     `description:"权限名"`
	Child             []*ChartPermissionTreeView `description:"子权限"`
	IsPublic          int                        `description:"是否是公有权限1:公有权限，0私有权限"`
	ParentId          int                        `description:"父级权限id"`
	Sort              int                        `description:"排序" json:"-"`
}
