package response

import (
	"eta/eta_mini_api/models"
	"time"

	"github.com/rdlucklib/rdluck_tools/paging"
)

type ReportList struct {
	List   []*models.ReportList
	Paging *paging.PagingItem
}

type ReportResp[T any] struct {
	Ret    int
	Data   T
	Msg    string
	ErrMsg string
}
type ReportDetailResp struct {
	Report    *models.ReportDetail `description:"报告"`
	Status    int                  `description:"报告状态"`
	IsCollect bool                 `description:"报告是否收藏"`
}

type ReportCollectListItem struct {
	ReportId            int       `description:"报告Id"`
	ReportChapterId     int       `description:"报告章节Id"`
	ClassifyIdFirst     int       `description:"一级分类id"`
	ClassifyNameFirst   string    `description:"一级分类名称"`
	ClassifyIdSecond    int       `description:"二级分类id"`
	ClassifyNameSecond  string    `description:"二级分类名称"`
	ReportChapterTypeId int       `decription:"报告章节类型id"`
	PublishTime         time.Time `description:"发布时间"`
	Title               string    `description:"标题"`
	ContentSub          string    `description:"内容前两个章节"`
	Abstract            string    `description:"摘要"`
	Stage               string    `description:"期数"`
	Author              string    `description:"作者"`
}

type ReportSearchListView struct {
	ReportId            int    `description:"报告Id"`
	ReportChapterId     int    `description:"报告章节Id"`
	ClassifyIdFirst     int    `description:"一级分类id"`
	ClassifyNameFirst   string `description:"一级分类名称"`
	ClassifyIdSecond    int    `description:"二级分类id"`
	ClassifyNameSecond  string `description:"二级分类名称"`
	ReportChapterTypeId int    `decription:"报告章节类型id"`
	PublishTime         string `description:"发布时间"`
	Title               string `description:"标题"`
	ContentSub          string `description:"内容前两个章节"`
	Abstract            string `description:"摘要"`
	Stage               string `description:"期数"`
	Author              string `description:"作者"`
}

type ReportSearchResp struct {
	Paging *paging.PagingItem
	List   []*ReportCollectListItem
}
type ReportSearchViewResp struct {
	Paging *paging.PagingItem
	List   []*ReportSearchListView
}
